package com.airlinecompany.flightservice.service.impl;

import br.ufpe.rise.travelagency.coreagency.entity.util.price.Price;

import com.airlinecompany.flightservice.service.IFlightService;

public class FlightService implements IFlightService {
	
	private int flightNb;
    private String dest;
    private String plane;
    private String[] seats;
    private int nbReservation;
    private Price price;
    
    public FlightService(){
    	nbReservation = 0;
    }
	
	@Override
	public String destination() {
		
		return new String(dest);
	}

	@Override
	public int flight() {
		
		return flightNb;
	}

	@Override
	public boolean isFull() {
		
		return (nbReservation >= seats.length);
	}

	@Override
	public int makeReservation(String name) {
		int ret = -1;
		int i=0;
		
		while((i < seats.length) && seats[i].compareTo("no")!=0) 
			i++;
		
		if(i < seats.length){
			seats[i] = new String(name);
			nbReservation++;
			ret = i;
		}
		
		return ret; 
	}
	
	@Override
	public void setPrice(Price price){
		this.price = price;
	}

	@Override
	public double getPrice() {
		
		 return price.price();
	}

	@Override
	public boolean removeReservation(int seat) {
		boolean ret = false;
		
		if((seat<seats.length) && (seats[seat].compareTo("no")!=0)){
			seats[seat] = "no";
			ret = true;
		}
		
		return ret; 
	}

	@Override
	public String ticket(int seatNb) {
		
		String ret = "No reservation for seat "+ seatNb;
		
		if((seatNb < seats.length) && ((seats[seatNb]).compareTo("no")!=0)){
			
			ret = "Flight Num.: "+ flight() +"  Plane: "+plane+" Destination: " +
					destination() +"   Passenger: "+ seats[seatNb] +"   Seat: " + 
					seatNb +"   Amount: "+ getPrice();
		}
		
		return ret;
    }
}