package br.ufpe.rise.travelagency.billet.component.impl;

import org.jboleto.JBoleto;
import org.jboleto.control.Generator;
import org.jboleto.control.PDFGenerator;

import br.ufpe.rise.travelagency.billet.component.IBilletComponent;
import br.ufpe.rise.travelagency.billet.entity.Billet;
import br.ufpe.rise.travelagency.billet.entity.IBillet;

public class BilletComponentImpl implements IBilletComponent {
	
	private IBillet billet;
	private JBoleto jb;
	private Generator generator;
	
	public BilletComponentImpl(){
	
	}
	
	public void createBillet(IBillet billet){
		if(billet == null){
			this.billet = new Billet();
		}else {
			this.billet = billet;
		}
	}
	
	public IBillet getBillet(){
		return this.billet;
	}
	
	public void generateBillet(int bankCode, String inputFile){
		try {
			generator = new PDFGenerator(this.billet.getBillet(), bankCode);
		
			jb = new JBoleto(generator, this.billet.getBillet(), bankCode);
			
			jb.addBoleto();
			
			jb.closeBoleto(inputFile);
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
}