package br.ufpe.rise.travelagency.billet.entity;

import java.text.ParseException;
import java.util.Date;

import br.ufpe.rise.travelagency.coreagency.entity.customer.ICustomer;
import br.ufpe.rise.travelagency.coreagency.entity.util.ObjectUtil;

public class Billet implements IBillet {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6822226319277333646L;
	
	private BilletBrazilModel billet;
	private ICustomer customer;
	private DataConversor conversor;
	private BilletBankType type;
	
	public Billet(){
		billet = new BilletBrazilModel();
		conversor = new DataConversor("dd/MM/yyyy");
	}

	public ICustomer getCustomer() {
		return customer;
	}

	public void setCustomer(ICustomer customer) {
		this.customer = customer;
	}

	public BilletBrazilModel getBillet() {
		return billet;
	}

	public void setBillet(BilletBrazilModel billet) {
		this.billet = billet;
	}
	
	public void setTransferor(String transferor) {
		this.billet.setCedente(transferor);
	}

	public void setDocumentDate(Date documentDate) {
		try {
			String dateTmp = this.conversor.convert(documentDate);
			
			this.billet.setDataDocumento(dateTmp);
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}

	public void setProcessDate(Date processDate) {
		try {
			String dateTmp = this.conversor.convert(processDate);
			
			this.billet.setDataProcessamento(dateTmp);
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}

	public void setExpirationDate(Date expirationDate) {
		try {
			String dateTmp = this.conversor.convert(expirationDate);
			
			this.billet.setDataVencimento(dateTmp);
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}

	public void setPurse(String purse) {
		this.billet.setCarteira(purse);
	}
	
	public void setAgency(String agency) {
		this.billet.setAgencia(agency);
	}

	public void setAccount(String account) {
		this.billet.setContaCorrente(account);
	}

	public void setAccountDV(String accountDV) {
		this.billet.setDvContaCorrente(accountDV);
	}
	
	public void setOurNumber(String ourNumber) {
		this.billet.setNossoNumero(ourNumber);
	}

	public void setDocumentNumber(String documentNumber) {
		this.billet.setNoDocumento(documentNumber);
	}

	public void setBilletValue(String billetValue) {
		this.billet.setValorBoleto(billetValue);
	}

	public void setInstrunction1(String instrunction1) {
		this.billet.setInstrucao1(instrunction1);
	}

	public void setInstrunction2(String instrunction2) {
		this.billet.setInstrucao2(instrunction2);
	}

	public void setInstrunction3(String instrunction3) {
		this.billet.setInstrucao3(instrunction3);
	}

	public void setInstrunction4(String instrunction4) {
		this.billet.setInstrucao4(instrunction4);
	}

	public void setInstrunction5(String instrunction5) {
		this.billet.setInstrucao5(instrunction5);
	}

	public void setAcceptance(Character acceptance) {
		this.billet.setAceite(acceptance.toString());
	}
	
	public BilletBankType getType() {
		return type;
	}

	public void setType(BilletBankType type) {
		this.type = type;
	}

	@Override
	public String toString() {
		return ObjectUtil.toString(this);
	}
}