package br.ufpe.rise.travelagency.coreagency.component.impl;

import java.util.List;

import br.ufpe.rise.travelagency.coreagency.component.ICoreAgencyComponent;
import br.ufpe.rise.travelagency.coreagency.dao.hibernate.CustomerDao;
import br.ufpe.rise.travelagency.coreagency.dao.hibernate.IntineraryDao;
import br.ufpe.rise.travelagency.coreagency.entity.customer.ICustomer;
import br.ufpe.rise.travelagency.coreagency.entity.intinerary.IIntinerary;

public class CoreAgencyComponentImpl implements ICoreAgencyComponent {

	private IntineraryDao intineraryDao;
	private CustomerDao customerDao;
	
	public CoreAgencyComponentImpl(){
		
	}

	public void setIntineraryDao(IntineraryDao intineraryDao) {
		this.intineraryDao = intineraryDao;
	}

	public void setCustomerDao(CustomerDao customerDao) {
		this.customerDao = customerDao;
	}

	@Override
	public List<IIntinerary> getIntineraries() {
		
		return this.intineraryDao.getIntineraries();
	}

	@Override
	public IIntinerary getIntineraryById(Long id) {
		
		return this.intineraryDao.getById(id);
	}

	@Override
	public void remove(IIntinerary intinerary) {
		this.intineraryDao.remove(intinerary);
	}

	@Override
	public void save(IIntinerary intinerary) {
		this.intineraryDao.save(intinerary);
	}

	@Override
	public void update(IIntinerary intinerary) {
		this.intineraryDao.update(intinerary);
	}
	
	@Override
	public ICustomer getCustomerById(Long id) {
		
		return this.customerDao.getById(id);
	}

	@Override
	public List<ICustomer> getCustomers() {
		
		return this.customerDao.list();
	}

	@Override
	public void remove(ICustomer customer) {
		this.customerDao.remove(customer);
	}

	@Override
	public void save(ICustomer customer) {
		this.customerDao.save(customer);
	}

	@Override
	public void update(ICustomer customer) {
		this.customerDao.update(customer);
	}
}