package br.ufpe.rise.travelagency.coreagency.entity.customer;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import br.ufpe.rise.travelagency.bank.Account;
import br.ufpe.rise.travelagency.bank.IAccount;

public class Customer implements ICustomer {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6989088260925294504L;
	
	private Long id;
	private String password;
	private IAddress address;
	private Collection<IAccount> accounts;
	private ICPF cpf;
	private IEmail email;
	private IPhone phone;
	private IRG rg;
	
	public Customer(){
		this.accounts = new ArrayList<IAccount>();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public IAddress getAddress() {
		return address;
	}

	public void setAddress(IAddress address) {
		this.address = address;
	}
	
	public ICPF getCpf() {
		return cpf;
	}

	public void setCpf(ICPF cpf) {
		this.cpf = cpf;
	}

	public IEmail getEmail() {
		return email;
	}

	public void setEmail(IEmail email) {
		this.email = email;
	}

	public IPhone getPhone() {
		return phone;
	}

	public void setPhone(IPhone phone) {
		this.phone = phone;
	}

	public IRG getRg() {
		return rg;
	}

	public void setRg(IRG rg) {
		this.rg = rg;
	}

	public IAccount getAccount(String accountNumber){
		Iterator<IAccount> it = accounts.iterator();
		
		while(it.hasNext()){
			IAccount a = it.next();
			
			if(a.getAccountNumber().equals(accountNumber)){
				return a;
			}
		}
		
		return null;
	}
	
	public synchronized IAccount createAccount(String number){
		IAccount a = getAccount(number);

		if (a == null) {
			a = new Account(number, this);
		}

		return a;
	}
}