package br.ufpe.rise.travelagency.creditcard.entity;

import br.ufpe.rise.travelagency.coreagency.entity.customer.ICustomer;

public class CreditCard implements ICreditCard {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6593172387087855502L;
	
	private Long id;
	private String number;
    private CreditCardType type;
    private ICustomer customer;
   
    public CreditCard(){
    	
    }

    public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNumber() {
		return number;
	}

	public void setNumber(String number) {
		this.number = number;
	}

	public ICustomer getCustomer() {
		return customer;
	}

	public void setCustomer(ICustomer customer) {
		this.customer = customer;
	}

	public String getProtectedCreditCardNumber() {
        return format(getCreditCardNumberWithoutPunctuation(), type, true);
    }

    public String getCreditCardNumberWithoutPunctuation() {
        StringBuffer ccNoPunc = new StringBuffer();

        for (int i = 0; i < this.number.length(); i++) {
            char currentChar = this.number.charAt(i);
            if (Character.isDigit(currentChar)) {
                ccNoPunc.append(currentChar);
            }
        }

        return ccNoPunc.toString();
    }
    
    public CreditCardType getType() {
        return type;
    }

    public void setType(CreditCardType type) {
        this.type = type;
    }
    
    private String format(String creditCardNumber, CreditCardType type, boolean protect) {
        //Clear out any existing dashes or spaces
        String ccNumberToFormat = creditCardNumber.replaceAll("[ ]|-", "");

        if (protect) {
            StringBuffer protectedNumber = new StringBuffer();
            for (int i = 0; i < creditCardNumber.length()-4; i++) {
                protectedNumber.append("X");
            }
            protectedNumber.append(creditCardNumber.substring(creditCardNumber.length()-4));
            ccNumberToFormat = protectedNumber.toString();
        }

        return type.formatNumberString(ccNumberToFormat);
    }
}