package com.hotel.common.entity;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.util.Date;

public class Booking implements IBooking {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1039553697068145954L;
	
	private Long id;
	private Object user;
	private IHotel hotel;
	private Date checkinDate;
	private Date checkoutDate;
	private String creditCard;
	private String creditCardName;
	private int creditCardExpiryMonth;
	private int creditCardExpiryYear;
	private boolean smoking;
	private int beds;

	public Booking(){
		
	}

	public Booking(IHotel hotel, Object user){
		this.hotel = hotel;
		this.user = user;
	}

	public BigDecimal getTotal(){
		int i = (int) hotel.price();
		BigDecimal price = new BigDecimal(i);
		
		return price.multiply( new BigDecimal( getNights() ) );
	}

	public int getNights(){
		return (int) ( checkoutDate.getTime() - checkinDate.getTime() ) 
				/ 1000 / 60 / 60 / 24;
	}

	public Long getId(){
		return id;
	}
	
	public void setId(Long id){
		this.id = id;
	}

	public Date getCheckinDate(){
		return checkinDate;
	}
	
	public void setCheckinDate(Date datetime){
		this.checkinDate = datetime;
	}

	public IHotel getHotel(){
		return hotel;
	}
	
	public void setHotel(IHotel hotel){
		this.hotel = hotel;
	}

	public Object getUser(){
		return user;
	}
	
	public void setUser(Object user){
		this.user = user;
	}

	public Date getCheckoutDate(){
		return checkoutDate;
	}
	
	public void setCheckoutDate(Date checkoutDate){
		this.checkoutDate = checkoutDate;
	}

	public String getCreditCard(){
		return creditCard;
	}

	public void setCreditCard(String creditCard){
		this.creditCard = creditCard;
	}

	public String getDescription(){
		
		DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM);
		
		return hotel==null ? null : hotel.getName() + 
				", " + df.format( getCheckinDate() ) + 
				" to " + df.format( getCheckoutDate() );
	}

	public boolean isSmoking(){
		return smoking;
	}

	public void setSmoking(boolean smoking){
		this.smoking = smoking;
	}

	public int getBeds(){
		return beds;
	}

	public void setBeds(int beds){
		this.beds = beds;
	}
	
	public String getCreditCardName(){
		return creditCardName;
	}

	public void setCreditCardName(String creditCardName){
		this.creditCardName = creditCardName;
	}

	public int getCreditCardExpiryMonth(){
		return creditCardExpiryMonth;
	}

	public void setCreditCardExpiryMonth(int creditCardExpiryMonth){
		this.creditCardExpiryMonth = creditCardExpiryMonth;
	}

	public int getCreditCardExpiryYear(){
		return creditCardExpiryYear;
	}

	public void setCreditCardExpiryYear(int creditCardExpiryYear){
		this.creditCardExpiryYear = creditCardExpiryYear;
	}

	@Override
	public String toString(){
		return "Booking(" + user + ","+ hotel + ")";
	}
}