package br.com.rise.notification.service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Properties;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

/**
 * 
 * @author heberthbraga
 *
 */
public class Mailer {

	//public static String SMTP_SERVER = "smtp.cin.ufpe.br";
	public static String SMTP_SERVER = "localhost";

	protected String from;
	protected String[] recipients;
	protected String subject;
	protected String message;
	protected ICallback callback;

	public Mailer(String from, String[] recipients, String subject,
			String message, ICallback callback) {
		super();
		this.from = from;
		this.recipients = recipients;
		this.subject = subject;
		this.message = message;
		this.callback = callback;
	}

	public static void setSmtpHost(String host) {
		SMTP_SERVER = host;
	}

	public Mailer() {
		super();
	}

	public void sendMail() {
		try {
			sendPlaintextMail();
			callback.onSuccess();
		} catch (MessagingException ex) {
			callback.onFailure(ex);
		}
	}

	private void sendPlaintextMail() throws MessagingException {
		Properties props = new Properties();

		props.put("mail.smtp.host", SMTP_SERVER);

		Session session = Session.getInstance(props);

		Message msg = new MimeMessage(session);

		msg.setFrom(new InternetAddress(from));

		msg.setRecipients(Message.RecipientType.TO, recipients());

		msg.setSubject(subject);
		msg.setSentDate(new Date());

		msg.setText(message);

		Transport.send(msg);
	}

	private InternetAddress[] recipients() throws AddressException {
		List<InternetAddress> addresses = new ArrayList<InternetAddress>();

		for (String recipient : recipients) {
			addresses.add(new InternetAddress(recipient));
		}
		InternetAddress[] addressArr = addresses
				.toArray(new InternetAddress[addresses.size()]);
		return addressArr;
	}
}