package br.ufpe.rise.travelagency.component;

import java.util.List;

import br.ufpe.rise.travelagency.bank.IAccount;
import br.ufpe.rise.travelagency.bank.IBank;
import br.ufpe.rise.travelagency.payment.IPayment;

public interface IPaymentComponent {

	List<IAccount> getAccounts();

	IAccount getAccountById(Long id);

	void remove(IAccount account);

	void save(IAccount account);

	void update(IAccount account);
	
	List<IBank> getBanks();

	IBank getBankById(Long id);

	void remove(IBank bank);

	void save(IBank bank);

	void update(IBank bank);
	
	List<IPayment> getPayments();

	IPayment getPaymentById(Long id);

	void remove(IPayment payment);

	void save(IPayment payment);

	void update(IPayment payment);
}