package br.ufpe.rise.travelagency.component.impl;

import java.util.List;

import br.ufpe.rise.travelagency.bank.IAccount;
import br.ufpe.rise.travelagency.bank.IBank;
import br.ufpe.rise.travelagency.component.IPaymentComponent;
import br.ufpe.rise.travelagency.payment.IPayment;
import br.ufpe.rise.travelagency.payment.dao.hibernate.AccountDao;
import br.ufpe.rise.travelagency.payment.dao.hibernate.BankDao;
import br.ufpe.rise.travelagency.payment.dao.hibernate.PaymentDao;

public class PaymentComponent implements IPaymentComponent {

	private AccountDao accountDao;
	private PaymentDao paymentDao;
	private BankDao bankDao;
	
	public PaymentComponent(){
		
	}

	public void setAccountDao(AccountDao accountDao) {
		this.accountDao = accountDao;
	}

	public void setPaymentDao(PaymentDao paymentDao) {
		this.paymentDao = paymentDao;
	}
	
	public void setBankDao(BankDao bankDao) {
		this.bankDao = bankDao;
	}

	@Override
	public IAccount getAccountById(Long id) {
		
		return this.accountDao.getById(id);
	}

	@Override
	public List<IAccount> getAccounts() {
		
		return this.accountDao.list();
	}

	@Override
	public IBank getBankById(Long id) {
		
		return this.bankDao.getById(id);
	}

	@Override
	public List<IBank> getBanks() {
		
		return this.bankDao.list();
	}

	@Override
	public IPayment getPaymentById(Long id) {
		
		return this.paymentDao.getById(id);
	}

	@Override
	public List<IPayment> getPayments() {
		
		return this.paymentDao.list();
	}

	@Override
	public void remove(IAccount account) {
		this.accountDao.remove(account);
	}

	@Override
	public void remove(IBank bank) {
		this.bankDao.remove(bank);
	}

	@Override
	public void remove(IPayment payment) {
		this.paymentDao.remove(payment);
	}

	@Override
	public void save(IAccount account) {
		this.accountDao.save(account);
	}

	@Override
	public void save(IBank bank) {
		this.bankDao.save(bank);
	}

	@Override
	public void save(IPayment payment) {
		this.paymentDao.save(payment);
	}

	@Override
	public void update(IAccount account) {
		this.accountDao.update(account);
	}

	@Override
	public void update(IBank bank) {
		this.bankDao.update(bank);
	}

	@Override
	public void update(IPayment payment) {
		this.paymentDao.update(payment);
	}
}