package br.ufpe.rise.travelagency.service;

import java.util.List;

import br.ufpe.rise.travelagency.bank.IAccount;
import br.ufpe.rise.travelagency.billet.entity.BilletBankType;
import br.ufpe.rise.travelagency.billet.entity.IBillet;
import br.ufpe.rise.travelagency.creditcard.entity.ICreditCard;
import br.ufpe.rise.travelagency.payment.IPayment;

public interface IPaymentService {

	boolean verifyCreditCard();
	
	ICreditCard createCreditCard();
	
	void generateBillet(int bankCode, String inputFile);
	
	IBillet createBillet(BilletBankType type);
	
	void addPayment(IPayment payment);
	
	List<IPayment> getPayments();
	
	void addAccount(IAccount account);
	
	List<IAccount> getAccounts();
	
	IAccount getAccountById(Long id);
}