package br.ufpe.rise.travelagency.reservation.component.impl;

import java.util.List;

import br.ufpe.rise.travelagency.reservation.component.IReserveComponent;
import br.ufpe.rise.travelagency.reservation.dao.hibernate.ReserveDao;
import br.ufpe.rise.travelagency.reservation.entity.IReserve;

public class ReserveComponentImpl implements IReserveComponent {

	private ReserveDao reserveDao;
	
	public ReserveComponentImpl(ReserveDao reserveDao){
		this.reserveDao = reserveDao;
	}

	@Override
	public IReserve getReservById(Long id) {
		
		return this.reserveDao.getById(id);
	}

	@Override
	public List<IReserve> getReserves() {
		
		return this.reserveDao.list();
	}

	@Override
	public void remove(IReserve reserve) {
		this.reserveDao.remove(reserve);
	}

	@Override
	public void save(IReserve reserve) {
		this.reserveDao.save(reserve);
	}	
}