package br.ufpe.rise.travelagency.reservation.service.impl;

import java.util.List;

import br.ufpe.rise.travelagency.reservation.component.IReserveComponent;
import br.ufpe.rise.travelagency.reservation.entity.IReserve;
import br.ufpe.rise.travelagency.reservation.service.IReservationService;

public class ReservationServiceImpl implements IReservationService {
	
	private IReserveComponent reserveComponent;
	private Common common;
	
	public ReservationServiceImpl(Common common){
		this.common = common;
	}
	
	public void makeReservation(){
		this.common.makeReservation();
	}
	
	public void setReserveComponent(IReserveComponent reserveComponent) {
		this.reserveComponent = reserveComponent;
	}

	@Override
	public void addReserve(IReserve reserve) {
		this.reserveComponent.save(reserve);
	}

	@Override
	public IReserve getReservById(Long id) {
		
		return this.reserveComponent.getReservById(id);
	}

	@Override
	public List<IReserve> getReserves() {
		
		return this.reserveComponent.getReserves();
	}

	@Override
	public void removeReserve(IReserve reserve) {
		this.reserveComponent.remove(reserve);
	}
}