create table User (
	id bigint not null auto_increment primary key,
	email varchar(120) not null unique,
	firstname varchar(80) not null,
	lastname varchar(80) not null,
	middlename varchar(80) not null,
	organization varchar(150) not null,
	password varchar(10) not null
);

create table Author(
	id bigint not null unique,
	submissionid bigint unique,
	foreign key (id) references User (id) ON UPDATE CASCADE ON DELETE CASCADE,
	foreign key (submissionid) references Submission (id) ON UPDATE CASCADE ON DELETE NO ACTION
);

create table Reviewer (
	id bigint not null unique,
	foreign key (id) references User(id) ON UPDATE CASCADE ON DELETE CASCADE
);

create table Chair (
	id bigint not null unique,
	chairtype int not null unique,
	foreign key (id) references User(id) ON UPDATE CASCADE ON DELETE CASCADE
);

create table Administrator (
	id bigint not null unique,
	foreign key (id) references User(id) ON UPDATE CASCADE ON DELETE CASCADE
);