package br.com.rise.roles.component.impl;

import java.util.List;

import br.com.rise.roles.component.IRolesComponent;
import br.com.rise.roles.dao.hibernate.RolesDao;
import br.com.rise.roles.model.entity.IUser;

public class RolesComponentImpl implements IRolesComponent {
	
	private RolesDao rolesDao;
	
	public RolesComponentImpl(){
		
	}
	
	public void setRolesDao(RolesDao rolesDao){
		this.rolesDao = rolesDao;
	}
	
	@Override
	public void delete(IUser user) {
		this.rolesDao.delete(user);
	}

	@Override
	public IUser getRoleById(Long id) {
		
		return this.rolesDao.getById(id);
	}

	@Override
	public List<IUser> getRoles() {
		
		return this.rolesDao.listAll();
	}

	@Override
	public void save(IUser user) {
		this.rolesDao.save(user);
	}

	@Override
	public void update(IUser user) {
		this.rolesDao.update(user);
	}

	@Override
	public IUser getByLoginAndPassword(IUser user) {
		
		return this.rolesDao.getByLoginAndPassword(user);
	}
}