package br.com.rise.roles.dao.hibernate;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import br.com.rise.data.access.hibernate.DataAccessHibernate;
import br.com.rise.roles.model.entity.IUser;

/**
 * 
 * @author heberthbraga
 *
 */
public class RolesDao {

	private DataAccessHibernate<IUser> roleAccess;
	
	public RolesDao(){
		
	}

	public void setRoleAccess(DataAccessHibernate<IUser> roleAccess) {
		this.roleAccess = roleAccess;
	}
	
	public void save(IUser user){
		
		this.roleAccess.persist(user);
	}
	
	public void update(IUser user){
		this.roleAccess.update(user);
	}
	
	public IUser getById(Object id){
		
		return this.roleAccess.getById(id);
	}
	
	public List<IUser> listAll(){
		
		return this.roleAccess.listAll();
	}
	
	public void delete(IUser user){
		this.roleAccess.delete(user);
	}
	
	public IUser getByLoginAndPassword(IUser user){
		
		String search = "from User u where u.email = :param0 ";
		Collection<Object> parameters = new ArrayList<Object>();
		parameters.add(user.getEmail());
		ArrayList<IUser> users = new ArrayList<IUser>();
		
		Collection<Object> resultado = this.roleAccess.find(search, parameters);
		Iterator<Object> itResult = resultado.iterator();
		IUser pUser = null;
		
		while (itResult.hasNext()) {
			pUser = (IUser) itResult.next(); 
			users.add(pUser);
		}
		
		if (users.size() > 0)
			return users.get(0);
		
		return null;
	}
}