package br.ufpe.rise.travelagency.coreagency.entity.util;

import static br.ufpe.rise.travelagency.coreagency.entity.util.ObjectUtil.isNotNull;

import org.apache.commons.lang.StringUtils;

public class StringUtil {

	public static final String WHITE_SPACE = " ";
	
	private StringUtil() {
		throw new AssertionError();
	}
	
	public static String eliminateSymbols(final String str){
		
		String modifiedStr = str;
		
		if(isNotNull(modifiedStr)){
			
			modifiedStr = StringUtils.replace(str,"-", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"_", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"=", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"+", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"%", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"*", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"@", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"#", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"&", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,":", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,".", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,";", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,",", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"!", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"?", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"(", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,")", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"{", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"}", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"[", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"]", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"/", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"\\", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,">", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"<", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"\"", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"'", StringUtils.EMPTY);
			modifiedStr = StringUtils.replace(str,"`", StringUtils.EMPTY);
		}
			
		return modifiedStr;
	}
		
	public static String removeStartWithZeros(final String str){
		
		String withoutZeros = StringUtils.EMPTY;
		final String zero = "0";
		
		if (isNotNull(str)) {
			
			if (StringUtils.contains(str, zero)) {
				
				withoutZeros = StringUtils.removeStart(str, zero);

				while (StringUtils.contains(withoutZeros, zero)) {
					withoutZeros = StringUtils.removeStart(withoutZeros, zero);
				}
				
				if(withoutZeros.trim().length() == 0) {
					withoutZeros = zero;
				}
				
			} else {
				withoutZeros = str;
			}
		}

		return withoutZeros;
	}
	
	public static String eliminateAccent(final String value) {
		
		String modifiedValue = value;
		
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E7', 'c');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C7', 'C');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E0', 'a');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E1', 'a');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E2', 'a');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E3', 'a');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E4', 'a');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E8', 'e');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00E9', 'e');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00EA', 'e');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00EB', 'e');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00EC', 'i');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00ED', 'i');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00EE', 'i');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00EF', 'i');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00F2', 'o');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00F3', 'o');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00F4', 'o');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00F5', 'o');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00F6', 'o');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00F9', 'u');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00FA', 'u');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00FB', 'u');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00FC', 'u');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C0', 'A');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C1', 'A');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C2', 'A');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C3', 'A');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C4', 'A');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C8', 'E');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00C9', 'E');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00CA', 'E');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00CB', 'E');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00CC', 'I');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00CD', 'I');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00CE', 'I');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00CF', 'I');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00D2', 'O');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00D3', 'O');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00D4', 'O');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00D5', 'O');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00D6', 'O');

		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00D9', 'U');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00DA', 'U');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00DB', 'U');
		modifiedValue = StringUtils.replaceChars(modifiedValue, '\u00DC', 'U');
		
		return modifiedValue;
	}
}