package com.vehicleagency.vehicle.service.impl;

import java.util.HashMap;
import java.util.Map;

import com.vehicleagency.vehicle.entity.Vehicle;
import com.vehicleagency.vehicle.service.IVehicleService;

public class VehicleService implements IVehicleService {
	
	private Map<Integer, Vehicle> vehicleType;
	
	public VehicleService(){
		this.vehicleType = new HashMap<Integer, Vehicle>();
		
	}
	
	public void addCarType(Integer key, Vehicle vehicle){
		
		if(key != null && vehicle != null){
			
			this.vehicleType.put(key, vehicle);
		}
	}
	
	public void removeCar(Integer key){
		if(key != null){
			if(this.vehicleType.containsKey(key)){
				this.vehicleType.remove(key);
			}
		}
	}
		
	public Vehicle getCarTpe(Integer key){
		if(key != null){
			Vehicle v = this.vehicleType.get(key);
			
			return v;
		}
		
		return null;
	}
	
	public double calculateCost(Vehicle vehicle, int noOfDays, int deposit){
		return (vehicle.charge() * noOfDays) + deposit;
	}

	@Override
	public void makeReservation() {
		
	}
}